<script lang="ts">
  import TextInput from "$lib/tidy/elements/input/TextInput.svelte";
  import { tagStore } from "$lib/local/stores/local.store";
  import { onMount } from "svelte";
  import { ButtonVariant } from "$lib/tidy/types/button.type";
  import ModalFooter from "$lib/tidy/components/modal/ModalFooter.svelte";
  import modalEvent from "$lib/tidy/components/modal/modal.store";
  import { confirmationNotification } from "$lib/tidy/stores/notification.store";
  import { PointronEventEnum } from "$lib/local/types/pointronEvent.enum";
  export let id: string;
  let label: string = "";
  let modalRef: any;
  async function onAdd() {
    if (!label || !id) return;
    return tagStore.updateTag({ label, id });
  }
  onMount(() => {
    label = $tagStore.tags.find((tag) => tag.id === id)?.label || "";
  });
</script>

<div class="flex flex-col h-full p-1 justify-between">
  <TextInput
    bind:value={label}
    placeholder={"Tag name"}
    on:keydown={(e) => {
      if (e.key === "Enter") {
        modalRef.close();
      }
    }}
  />
  <ModalFooter
    on:close={() => {
      modalEvent.hideSpecific(PointronEventEnum.EDIT_TAG);
    }}
    primaryAction={{
      label: "Update",
      callback: onAdd
    }}
    secondaryAction={{
      label: "Delete",
      variant: ButtonVariant.DANGER,
      callback: async () => {
        if (!id) return false;
        confirmationNotification.notify({
          title: "Delete tag",
          message: "Are you sure you want to delete this tag?",
          confirmAction: {
            label: "Delete",
            variant: ButtonVariant.DANGER,
            callback: () => tagStore.delete(id)
          }
        });
      }
    }}
  />
</div>
